//--------------------------------------------------------------------------------
// Timer 2 Interrupt Stuff
//--------------------------------------------------------------------------------
#include "m:\dev\usb\common firmware\fx2.h"
#include "M:\DEV\USB\COMMON FIRMWARE\fx2regs.h"
#include <string.h>
#include <absacc.h>
#include "ACCESFX2USBVR.h"
#include "T2ISR.h"
#include "CARD_SPECIFIC.h"

//*****************************************************************************
//   Firmware 2.0 Timer 2 ISR code
//*****************************************************************************

xdata BYTE T2DivisorH;
xdata BYTE T2DivisorL;
BYTE T2IRQOverrun;

void Timer2InitWithMSBLSBLoadValues(BYTE M, BYTE L)
{
    TH2   = RCAP2H = T2DivisorH = M;
    TL2   = RCAP2L = T2DivisorL = L;
    
    T2CON = 0x00;
 
    CKCON = (CKCON & bmSTRETCH) | 0x18; // slower Timer 2 speed (4MHz) (use 0x38 for 12MHz)
    PT2   = 1;                                                                          // Timer 2 IRQ priority = HIGH

    EA    = 1;                                                                          // enable IRQs in general (redundant on FW.C code)
    ET2   = 1;                                                                          // enable Timer 2 IRQs
    TR2   = 1;                                                                          // Start Timer 2 running    
    T2IRQOverrun = 0; 
}



void Timer2Init()
{
    // Timer2InitWithMSBLSBLoadValues(DEFBuf.GlobalTickDivisor.MSB, DEFBuf.GlobalTickDivisor.LSB);
}

BYTE Timer2GetOverruns(void)
{
    return T2IRQOverrun;
}



void Timer2InitWithDivisor(WORD Divisor)
{
    Timer2InitWithMSBLSBLoadValues(MSB(0-Divisor), LSB(0-Divisor));    
}


void Timer2DeInit(void)
{
    TR2 = 0;
    ET2 = 0;
}

void Timer2() interrupt TMR2_VECT  
{

#if (DIO_ByteCount)
#ifdef DEB_Go
  	if (DEFBuf.DEB_TickDivisor)      DEB_Go();
#endif
#ifdef LATCH_Go	
    if (DEFBuf.LATCH_TickDivisor)    LATCH_Go();
#endif
#ifdef PWM_Go	
    if (DEFBuf.PWM.Count)            PWM_Go();
#endif
#ifdef MAP_Go	
    if ((DEFBuf.MAP.Count) 
        && (DEFBuf.MAP.TickDivisor)) MAP_Go();
#endif			
#endif
#ifdef T2_HOOK_IMPLEMENTED
    T2HOOK_Go();
#endif    
	TF2 = 0; // ACK IRQ LAST
}
