#pragma NOIV					// Do not generate interrupt vectors
 
#include "m:\dev\usb\common firmware\fx2.h"
#include "M:\DEV\USB\COMMON FIRMWARE\fx2regs.h"
#include <absacc.h>
#include "ACCESFX2USBVR_BAE.h"
#include "USB-DIO-96.h"




BOOL dio96type;
BYTE DWA_DigBuf[12];
BYTE DWA_OutsBuf[4];

void ClrLED(void){ IOE = IOE | 0x20;}
void SetLED(void){ IOE = IOE & (~0x20);}
void TogLED(void){ IOE = IOE ^ 0x20;}

void DIO_Write1(BYTE bindex, BYTE value)   // REWRITE TO HANDLE DEFBUF UPDATING, AND FOR SPEED -- J2H TBD
{   
    BYTE bitmask = 1 << ( bindex & 0x07 );
    BYTE byteindex = (bindex >> 3) & 0x0F;
    
    if (byteindex > 5) 
        byteindex += 2; // reg @ 6&7 unused
    
    if (value)
       XBYTE[0x8000 + byteindex] |= bitmask; 
    else
       XBYTE[0x8000 + byteindex] &= ~bitmask;
    TogLED();
}

void DIO_WriteAll(BYTE volatile *buf)
{
    BYTE i;
    for ( i = 0; i < 6; i++ )
    {
        XBYTE[0x8000+i] = buf[i];	
        if (dio96type) 
		    XBYTE[0x8008+i] = buf[i+6];
    }
}

BYTE DIO_Read1(BYTE bindex)
{
    BYTE t;
    BYTE byteindex = (bindex >> 3);
    t = XBYTE[0x8000 + byteindex];

    t &= 1 << (bindex & 0x07);
    return t ? 1 : 0;
}

void DIO_ReadAll(BYTE volatile *buf)
{
	buf[0] = XBYTE[0x8000+0];
	buf[1] = XBYTE[0x8000+1];
	buf[2] = XBYTE[0x8000+2];
	buf[3] = XBYTE[0x8000+3];
	buf[4] = XBYTE[0x8000+4];
	buf[5] = XBYTE[0x8000+5];
	if (dio96type)
	{
		buf[6] = XBYTE[0x8008+0];
		buf[7] = XBYTE[0x8008+1];
		buf[8] = XBYTE[0x8008+2];
		buf[9] = XBYTE[0x8008+3];
		buf[10] = XBYTE[0x8008+4];
		buf[11] = XBYTE[0x8008+5];
	}
}

void DIO_WriteConfig(BYTE *buf, BYTE *tristateBitArray) // pass array of 1 config byte (with 4 bits used on this card), and array of 1 tristate byte (with d0 the only significant bit for this card)
{   
    BYTE i = dio96type ? 12 : 6; 
     //set port direction and global tristate
    if (dio96type) 
        IOB =  ((~buf[1]) & 0xF);
    IOA =  ~buf[0];
}  
//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
// DEF Code and Globals  


void DEF_Card_Specific_Init()
{
    BYTE i;
	
    IOA = 0xFF;
    IOB = 0x0F;
    OEA = 0xff; 
    OEB = 0x1f;
    OEE = 0x20;

    for ( i = 0; i < 6; i++ )
    {
        XBYTE[0x8000+i] = 0xFF; 
        if (dio96type) XBYTE[0x8008+i] = 0xFF; 
    }
}

void CS_PreInit()
{
	DEF_Card_Specific_Init();
}
    
void CS_NameMomentInit()
{ 
	  fActivity = 1;
	  EEPROMRead((WORD)3, (WORD)1, (WORD)EP0BUF);
    ((BYTE xdata*)&DeviceDscr)[10] = EP0BUF[0];          //update numeric portion of LSB
    switch(EP0BUF[0])
    { 
        case 0x02:OverwriteStringDscrM("USB-DIO-48"); dio96type = 0; break;
        case 0x03:OverwriteStringDscrM("USB-DIO-96"); dio96type = 1; break;
        default: OverwriteStringDscrM("ACCES USB-"); dio96type = 1; break;
    } 
}

void CS_PostInit()
{

    CPUCS = ((CPUCS & ~bmCLKSPD) | bmCLKSPD1); // set the CPU clock to 48MHz
    CKCON = CKCON&(~bmSTRETCH) | 0x03; // stretch external memory access cycles to fix 48MHz compatibility

//    CPUCS = ((CPUCS & ~bmCLKSPD) | bmCLKSPD0); // set the CPU clock to 24MHz
//    CPUCS = (CPUCS & ~bmCLKSPD); // set 12MHz for digital compatibility

} 		

void CS_PrePoll(){}

void CS_PostPoll()
{
	//DIO_ReadAll(DWA_DigBuf);
}
	
BOOL DR_VendorCmnd(void)
{
    BYTE i;
    fActivity = TRUE;

    switch(SETUPDAT[1])
    	{ //TPM handle new commands
		
      case AUR_DIO_READ:
	    case AUR_DIO_WRITE:
           if (USB_READ)
	         {  
					      
                 DIO_ReadAll(EP0BUF); // now performed in CS_PostPoll();						   
						 
								//for (i=0;i < (dio96type ? 12 : 6);i++)
						    //  EP0BUF[i] = DWA_DigBuf[i];
             
   				      EP0BCH = 0;
                EP0BCL = LengthLSB;
                EP0CS |= bmHSNAK;
           }else{
                EP0BCL = LengthLSB;
                while(EP0CS & bmEPBUSY);
                DIO_WriteAll(EP0BUF);
           }
           break;				
				 
          case AUR_DIO_CONFIG://0x12

                 EP0BCH = 0;
                 EP0BCL = LengthLSB;          // Inform chip we've taken all the data out of EP0
                 while(EP0CS & bmEPBUSY);
                 i = dio96type ? 12 : 6;
                 if ( (IndexLSB | IndexMSB) == 0 )                   // DIO_Configure called (not Ex), global tristate exists in setupdat[2]
                     DIO_WriteConfig(EP0BUF+i, &ValueLSB);    // set direction and 3state of each buffer
                 else // DIO_ConfigureEx called
                     DIO_WriteConfig(EP0BUF+i, &EP0BUF[1]);             // set direction and 3state of each buffer

								 DIO_WriteAll(EP0BUF);
                 break;
                 
          case AUR_DIO_READ_CONFIG:
                 EP0BUF[0] = ~IOA;
                 EP0BUF[1] = (~IOB) & 0x1F;  
	             EP0BCH = 0;
	             EP0BCL = LengthLSB;
                 break;

          default:
                 if (!HandleFW20VRs()) return 0x01;      // Stall End Point 0
                 break;
    	}
	return(FALSE); // no error; command handled OK
}

