#ifndef __ACCES_USB_DIO_96_H__
#define __ACCES_USB_DIO_96_H__

#define CTR_8254_BASE (0)
#define CTR_8254_BLOCK_OFFSET (0)
#define CTR_NumBlocks (0)
#define DIO_ByteCount           (12)
#define DIO_ControlByteCount    (2)
#define DAC_WordCount           (0)
#define ADC_SetConfigByteCount  (0)
#define DEB_Supported           (0xFF)
#define LATCH_Supported         (0xFF)

#define _CARD_SPECIFIC_MAP_HIGHESTDESTBITINDEX_  95
#define _CARD_SPECIFIC_MAP_HIGHESTSRCBITINDEX_   95

#define Vbus (IOE & 0x80)

//*************************************************************************************************
// these are hooks/variables that need to be defined in the card specific ".C" file
//*************************************************************************************************

// these are hooks/variables that need to be defined in the card specific ".C" file for DEF
void DEF_Card_Specific_Init();

void DEF_Card_Specific_RestoreFactoryDefaults();
void DEF_CARD_SPECIFIC_StoreCTRConfigModeLoad(BYTE b, BYTE c, BYTE mode, BYTE lb, BYTE mb);
void DEF_CARD_SPECIFIC_StoreCTRConfigMode(BYTE b, BYTE c, BYTE mode);

// these are hooks/variables that need to be defined in the card specific ".C" file for WDG
void SetLED();
void ClrLED();
void TogLED();
void WDG_CARD_SPECIFIC_DEFAULTS();
void WDG_CARD_SPECIFIC_BARK();

// these are hooks/variables that need to be defined in the card specific ".C" file for MAP
void MAP_CopySourceBitToDestBitX( BYTE s, BYTE d, BOOL finvert );
void MAP_SnapshotAcquire();
void MAP_UpdateDigitalOutputs();

void CS_PreInit();
void CS_PostInit();
void CS_PrePoll();
void CS_PostPoll();

void DIO_Write1(BYTE bindex, BYTE value);
BYTE DIO_Read1(BYTE bindex);
void DIO_WriteAll(BYTE *buf);
void DIO_ReadAll(BYTE *buf);

#define supports.DIOWriteConfig
void DIO_WriteConfig(BYTE *buf, BYTE *tristateBitArray);

#endif